// arr_xl_rw.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

#include <stdlib.h>
#include <memory.h>
#include <malloc.h>

//#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))

typedef long (__stdcall * l_pF_al)(double*, long);

double
sumArray(
	double arr[],
	long nLength )
{
	int i=0;
	double s=0;

	for(i=0;i<nLength;i++){
		s = s + arr[i];}

	return  s;
}

/* demanded from VBA ---------------------------------------------------*/

long __stdcall
receiveVBA(double *arrVBA_source, long nData)
// function holding a local array to receive data from VBA,
// arrVBA_source is the array defined within VBA
{
	double * arrDLL_destination;
	long nMax=0, nResult=0;

	arrDLL_destination = (double *)calloc(nData,sizeof(double));
	nMax = (long)( _msize(arrDLL_destination)/(double)(sizeof(double)) );
	
	memcpy(arrDLL_destination, arrVBA_source, nMax * (sizeof(double)));

	nMax = (long)( _msize(arrDLL_destination)/(double)(sizeof(double)) );

	// for testing do not return number of items, but their sum (as long)

	nResult = (long)sumArray(arrDLL_destination, nMax);

	free(arrDLL_destination);

	return nResult;
	//return nMax;
}

long __stdcall
deliverVBA(double *arrVBA_destination, long nData)
// function holding a local array which data are to be delivered to VBA
// arrVBA_destination is the array defined within VBA to which data are delivered
{
	double * arrDLL_source;
	long nDLL = 1000;
	long nMax;
	long i;

	arrDLL_source = (double *)calloc(nDLL,sizeof(double));
	
	// for testing fill with 1/i (zero based arrays in C)
	for(i=1;i<=nDLL;i++){
		arrDLL_source[i-1] = (double)1.0/i;}

	// care for size
	nMax = min( nDLL, nData );

	memmove(arrVBA_destination, arrDLL_source, nMax * (sizeof(double)));

	free(arrDLL_source);
	return nMax;
}

/* demanding from DLL ---------------------------------------------------*/

long
writeVBA(l_pF_al ptr_receiveVBA, long nData)
{
	double * arrDLL_source;
	long nMax, nResult;
	long nDLL = 0;
	long i;

	arrDLL_source = (double *)calloc(nData,sizeof(double));
	nDLL = (long)( _msize(arrDLL_source)/(double)(sizeof(double)) );

	// care for size
	nMax = min( nDLL, nData );

	// for testing fill with 1/i (zero based arrays in C)
	for(i=1;i<=nMax;i++){
		arrDLL_source[i-1] = (double)1.0/i;}

	// call the VBA function to receive the array
	nResult = ptr_receiveVBA(arrDLL_source, nMax);

	free(arrDLL_source);

	return nResult;
}

long
readVBA(l_pF_al ptr_deliverVBA, long nData)
{
	double * arrDLL_destination;
	long nMax, nResult;
	long nDLL = 0;

	arrDLL_destination = (double *)calloc(nData,sizeof(double));
	nDLL = (long)( _msize(arrDLL_destination)/(double)(sizeof(double)) );

	// care for size
	nMax = min( nDLL, nData );

	// call the VBA function to deliver the array
	nResult = ptr_deliverVBA(arrDLL_destination, nMax);

	// for testing sum up the entries
	nResult = (long)sumArray(arrDLL_destination, nMax);

	free(arrDLL_destination);

	return nResult;
}

/* triggers to be called from VBA to initiate the demand from DLL ----------*/

long __stdcall
trigger_writeVBA(l_pF_al ptr_receiveVBA, long nData)
{
	return writeVBA(ptr_receiveVBA, nData);
}

long __stdcall
trigger_readVBA(l_pF_al ptr_deliverVBA, long nData)
{
	return readVBA(ptr_deliverVBA, nData);
}